program morpion;
uses crt,graph;
var
prio,recherche,pos_deux,pos_trois,pos_quatre,nombre_croix,pos_mat_x,pos_mat_y,numero_coup:integer;
a,b,c,d,x,y,xx,yy:integer;
e:string[1];

feuille:array[1..40,1..40] of byte;
coups_joueur:array[1..100,1..2] of byte;
coups_ordi:array[1..100,1..2] of byte;
deux_en_ligne:array[1..20,1..3] of byte;
trois_en_ligne:array[1..20,1..3] of byte;
quatre_en_ligne:array[1..20,1..3] of byte;
priorite_coup:array[1..50,1..4] of byte;

procedure initialisation_graphique;
var
 graphdriver,graphmode,errcode:integer;
begin

 graphdriver:=detect;
 initgraph(graphdriver,graphmode,' ');
 errcode:=graphresult;
 if errcode<>grok then
 begin
   writeln('graphics error:', grapherrormsg(errcode));
   halt(1)
 end;
cleardevice;

end;

procedure dessin_feuille;

begin
for a:=1 to 615 do
begin
	line(a,1,a,getmaxy-39);
	a:=a+14;
end;
for a:=1 to 451 do
begin
	line(1,a,getmaxx-38,a);
	a:=a+10;
end;

end;

procedure piece_joueur;		{croix}
begin
setcolor (3);
line (a*15-13,b*11-9,a*15,b*11);
line (a*15-13,b*11,a*15,b*11-9);
end;

procedure piece_ordi;
begin
setcolor (4);
circle (a*15-6,b*11-4,4);
end;

procedure dessin_piece;
begin

for a:=1 to 40 do
for b:=1 to 40 do
begin
if feuille[a,b]=1 then
		piece_joueur;
if feuille[a,b]=2 then
		piece_ordi;
end;

end;

procedure init;
begin

setcolor(1);
recherche:=0;
pos_mat_x:=20;
pos_mat_y:=20;
pos_deux:=1;
pos_trois:=1;
pos_quatre:=1;
for a:=1 to 40 do
for b:=1 to 4 do
priorite_coup[a,b]:=0;
for a:=1 to 20 do
for b:=1 to 3 do
begin
deux_en_ligne[a,b]:=0;
trois_en_ligne[a,b]:=0;
quatre_en_ligne[a,b]:=0;
end;
prio:=1;
dessin_feuille;
dessin_piece;

end;

procedure dessin_position_curseur;
begin
setcolor(2);
rectangle(pos_mat_x*15+1,pos_mat_y*11+1,pos_mat_x*15-14,pos_mat_y*11-10);
setcolor(1);
rectangle(pos_mat_x*15+1,pos_mat_y*11+1,pos_mat_x*15-14,pos_mat_y*11-10);
end;

procedure choix_joueur;
begin

repeat;
repeat;
dessin_position_curseur;
until keypressed;
e:=readkey;

if e='K' then		{gauche}
		pos_mat_x:=pos_mat_x-1;
if e='M' then		{droite}
	pos_mat_x:=pos_mat_x+1;
if e='H' then		{haut}
		pos_mat_y:=pos_mat_y-1;
if e='P' then		{bas}
		pos_mat_y:=pos_mat_y+1;

until (e=' ') and (feuille[pos_mat_x,pos_mat_y]=0);	{acceptation du choix joueur}
feuille[pos_mat_x,pos_mat_y]:=1;	{code joueur}
coups_joueur[numero_coup,1]:=pos_mat_x;coups_joueur[numero_coup,2]:=pos_mat_y;

end;

procedure joueur_gagne;
begin
closegraph;
writeln ('joueur gagne');
readln;
end;

procedure hauteur_matrice;
begin

for a:=y-4 to y+4 do		{cherche pour la hauteur}
begin
if feuille[x,a]=1 then
                nombre_croix:=nombre_croix+1;
if ((feuille[x,a]=2) or (feuille[x,a]=0)) and (a<y) then
		nombre_croix:=0;
if ((feuille[x,a]=2) or (feuille[x,a]=0)) and (a>y) then
		a:=y+4;

end;

if nombre_croix=2 then
		for a:=y-4 to y+4 do
                if (feuille[x,a]=1) and (feuille[x,a+1]=1) then
                begin
                	deux_en_ligne[pos_deux,1]:=x;
                        deux_en_ligne[pos_deux,2]:=a;
                        deux_en_ligne[pos_deux+1,1]:=x;
                        deux_en_ligne[pos_deux+1,2]:=a+1;
                        deux_en_ligne[pos_deux,3]:=1;
                        pos_deux:=pos_deux+2;
                end;
if nombre_croix=3 then
		for a:=y-4 to y+4 do
                if (feuille[x,a]=1) and (feuille[x,a+1]=1) and (feuille[x,a+2]=1) then
                begin
                	trois_en_ligne[pos_trois,1]:=x;
                        trois_en_ligne[pos_trois,2]:=a;
                        trois_en_ligne[pos_trois+1,1]:=x;
                        trois_en_ligne[pos_trois+1,2]:=a+2;
                        trois_en_ligne[pos_trois,3]:=1;
                        pos_trois:=pos_trois+2;
                end;
if nombre_croix=4 then
		for a:=y-4 to y+4 do
                if (feuille[x,a]=1) and (feuille[x,a+1]=1) and (feuille[x,a+2]=1) and (feuille[x,a+3]=1) then
                begin
                	quatre_en_ligne[pos_quatre,1]:=x;
                        quatre_en_ligne[pos_quatre,2]:=a;
                        quatre_en_ligne[pos_quatre+1,1]:=x;
                        quatre_en_ligne[pos_quatre+1,2]:=a+3;
                        quatre_en_ligne[pos_quatre,3]:=1;
                        pos_quatre:=pos_quatre+2;
                end;

if nombre_croix>4 then
		joueur_gagne;
nombre_croix:=0;

end;

procedure largeur_matrice;
begin

for a:=x-4 to x+4 do		{cherche pour la largeur}
begin
if feuille[a,y]=1 then
                nombre_croix:=nombre_croix+1;
if ((feuille[a,y]=2) or (feuille[a,y]=0)) and (a<x) then
		nombre_croix:=0;
if ((feuille[a,y]=2) or (feuille[a,y]=0)) and (a>x) then
		a:=x+4;

end;

if nombre_croix=2 then
		for a:=x-4 to x+4 do
                if (feuille[a,y]=1) and (feuille[a+1,y]=1) then
                begin
                	deux_en_ligne[pos_deux,1]:=a;
                        deux_en_ligne[pos_deux,2]:=y;
                        deux_en_ligne[pos_deux+1,1]:=a+1;
                        deux_en_ligne[pos_deux+1,2]:=y;
                        deux_en_ligne[pos_deux,3]:=2;
                        pos_deux:=pos_deux+2;
                end;
if nombre_croix=3 then
		for a:=x-4 to x+4 do
                if (feuille[a,y]=1) and (feuille[a+1,y]=1) and (feuille[a+2,y]=1) then
                begin
                	trois_en_ligne[pos_trois,1]:=a;
                        trois_en_ligne[pos_trois,2]:=y;
                        trois_en_ligne[pos_trois+1,1]:=a+2;
                        trois_en_ligne[pos_trois+1,2]:=y;
                        trois_en_ligne[pos_trois,3]:=2;
                        pos_trois:=pos_trois+2;
                end;
if nombre_croix=4 then
		for a:=x-4 to x+4 do
                if (feuille[a,y]=1) and (feuille[a+1,y]=1) and (feuille[a+2,y]=1) and (feuille[a+3,y]=1) then
                begin
                	quatre_en_ligne[pos_quatre,1]:=a;
                        quatre_en_ligne[pos_quatre,2]:=y;
                        quatre_en_ligne[pos_quatre+1,1]:=a+3;
                        quatre_en_ligne[pos_quatre+1,2]:=y;
                        quatre_en_ligne[pos_quatre,3]:=2;
                        pos_quatre:=pos_quatre+2;
                end;

if nombre_croix>4 then
		joueur_gagne;
nombre_croix:=0;

end;

procedure diagonale_bas_gauche_droite;
begin

b:=y+5;
for a:=x-4 to x+4 do		{cherche pour la diagonale}
begin
b:=b-1;
if feuille[a,b]=1 then
                nombre_croix:=nombre_croix+1;
if ((feuille[a,b]=2) or (feuille[a,b]=0)) and (a<x) then
		nombre_croix:=0;
if ((feuille[a,b]=2) or (feuille[a,b]=0)) and (a>x) then
		a:=x+4;

end;

b:=y+5;
if nombre_croix=2 then
		for a:=x-4 to x+4 do
                begin
                        b:=b-1;
                	if (feuille[a,b]=1) and (feuille[a+1,b-1]=1) then
                	begin
                		deux_en_ligne[pos_deux,1]:=a;
                        	deux_en_ligne[pos_deux,2]:=b;
                                deux_en_ligne[pos_deux+1,1]:=a+1;
                        	deux_en_ligne[pos_deux+1,2]:=b-1;
                                deux_en_ligne[pos_deux,3]:=3;
     				pos_deux:=pos_deux+2;
        	        end;
		end;
if nombre_croix=3 then
		for a:=x-4 to x+4 do
                begin
                	b:=b-1;
	                if (feuille[a,b]=1) and (feuille[a+1,b-1]=1) and (feuille[a+2,b-2]=1) then
        	        begin
                		trois_en_ligne[pos_trois,1]:=a;
                        	trois_en_ligne[pos_trois,2]:=b;
                                trois_en_ligne[pos_trois+1,1]:=a+2;
                        	trois_en_ligne[pos_trois+1,2]:=b-2;
                                trois_en_ligne[pos_trois,3]:=3;
				pos_trois:=pos_trois+2;
                	end;
        	end;
if nombre_croix=4 then
		for a:=x-4 to x+4 do
                begin
                        b:=b-1;
	                if (feuille[a,b]=1) and (feuille[a+1,b-1]=1) and (feuille[a+2,b-2]=1) and (feuille[a+3,b-3]=1) then
        	        begin
                		quatre_en_ligne[pos_quatre,1]:=a;
                        	quatre_en_ligne[pos_quatre,2]:=b;
	                        quatre_en_ligne[pos_quatre+1,1]:=a+3;
        	                quatre_en_ligne[pos_quatre+1,2]:=b-3;
                                quatre_en_ligne[pos_quatre,3]:=3;
                	        pos_quatre:=pos_quatre+2;
	                end;
                end;
if nombre_croix>4 then
		joueur_gagne;
nombre_croix:=0;

end;

procedure diagonale_haut_gauche_droite;
begin

b:=y-5;
for a:=x-4 to x+4 do		{cherche pour la diagonale}
begin
b:=b+1;
if feuille[a,b]=1 then
                nombre_croix:=nombre_croix+1;
if ((feuille[a,b]=2) or (feuille[a,b]=0)) and (a<x) then
		nombre_croix:=0;
if ((feuille[a,b]=2) or (feuille[a,b]=0)) and (a>x) then
		a:=x+4;

end;

b:=y-5;
if nombre_croix=2 then
		for a:=x-4 to x+4 do
                begin
                        b:=b+1;
                	if (feuille[a,b]=1) and (feuille[a+1,b+1]=1) then
                	begin
                		deux_en_ligne[pos_deux,1]:=a;
                        	deux_en_ligne[pos_deux,2]:=b;
                                deux_en_ligne[pos_deux+1,1]:=a+1;
                        	deux_en_ligne[pos_deux+1,2]:=b+1;
                                deux_en_ligne[pos_deux,3]:=4;
     				pos_deux:=pos_deux+2;
        	        end;
		end;
if nombre_croix=3 then
		for a:=x-4 to x+4 do
                begin
                	b:=b+1;
	                if (feuille[a,b]=1) and (feuille[a+1,b+1]=1) and (feuille[a+2,b+2]=1) then
        	        begin
                		trois_en_ligne[pos_trois,1]:=a;
                        	trois_en_ligne[pos_trois,2]:=b;
                                trois_en_ligne[pos_trois+1,1]:=a+2;
                        	trois_en_ligne[pos_trois+1,2]:=b+2;
                                trois_en_ligne[pos_trois,3]:=4;
				pos_trois:=pos_trois+2;
                	end;
        	end;
if nombre_croix=4 then
		for a:=x-4 to x+4 do
                begin
                        b:=b+1;
	                if (feuille[a,b]=1) and (feuille[a+1,b+1]=1) and (feuille[a+2,b+2]=1) and (feuille[a+3,b+3]=1) then
        	        begin
                		quatre_en_ligne[pos_quatre,1]:=a;
                        	quatre_en_ligne[pos_quatre,2]:=b;
	                        quatre_en_ligne[pos_quatre+1,1]:=a+3;
        	                quatre_en_ligne[pos_quatre+1,2]:=b+3;
                                quatre_en_ligne[pos_quatre,3]:=4;
                        	pos_quatre:=pos_quatre+2;
                	end;
                end;
if nombre_croix>4 then
		joueur_gagne;
nombre_croix:=0;

end;

procedure decryptage_matrice;
begin

x:=coups_joueur[numero_coup,1];	{coordonnees x en matrice}
y:=coups_joueur[numero_coup,2];	{coordonnees y en matrice}

hauteur_matrice;
largeur_matrice;
diagonale_bas_gauche_droite;
diagonale_haut_gauche_droite;

end;

procedure deuxieme_recherche;
begin

xx:=0;
yy:=0;
x:=pos_mat_x;
y:=pos_mat_y;
if (feuille[x+1,y]=0) and (feuille[x+2,y]=1) and (feuille[x+3,y]=1) then
                begin
                xx:=1;
		end;
if (feuille[x-1,y]=0) and (feuille[x-2,y]=1) and (feuille[x-3,y]=1) then
	        begin
                xx:=-1;
		end;
if (feuille[x,y+1]=0) and (feuille[x,y+2]=1) and (feuille[x,y+3]=1) then
                begin
                yy:=1;
		end;
if (feuille[x,y-1]=0) and (feuille[x,y-2]=1) and (feuille[x,y-3]=1) then
		begin
                yy:=-1;
		end;
if (feuille[x+1,y+1]=0) and (feuille[x+2,y+2]=1) and (feuille[x+3,y+3]=1) then
		begin
                xx:=1;
                yy:=1;
		end;
if (feuille[x+1,y-1]=0) and (feuille[x+2,y-2]=1) and (feuille[x+3,y-3]=1) then
                begin
                xx:=1;
                yy:=-1;
		end;
if (feuille[x-1,y-1]=0) and (feuille[x-2,y-2]=1) and (feuille[x-3,y-3]=1) then
		begin
                xx:=-1;
                yy:=-1;
		end;
if (feuille[x-1,y+1]=0) and (feuille[x-2,y+2]=1) and (feuille[x-3,y+3]=1) then
		begin
                xx:=-1;
                yy:=1;
		end;

if (xx<>0) or (yy<>0) then
	begin
        priorite_coup[prio,1]:=x+xx;
        priorite_coup[prio,2]:=y+yy;
        priorite_coup[prio,3]:=1;
        priorite_coup[prio,3]:=35;
        prio:=prio+1;
        end;
end;

procedure premiere_recherche;	{le joueur a x pionts alignes et l'ordinateur bloque un des cotes}
begin

for a:=1 to 20 do
begin
        if recherche=2 then
        begin
                x:=deux_en_ligne[a,1];
                y:=deux_en_ligne[a,2];
                xx:=deux_en_ligne[a+1,1];
                yy:=deux_en_ligne[a+1,2];
                d:=deux_en_ligne[a,3];

{               closegraph;
               writeln ('x ',pos_mat_x,' y ',pos_mat_y);
               for b:=1 to 10 do
               writeln (deux_en_ligne[b,1],' ',deux_en_ligne[b,2]);

		readln;
               initialisation_graphique;}

        end;

        if recherche=3 then
        begin
                x:=trois_en_ligne[a,1];
                y:=trois_en_ligne[a,2];
                xx:=trois_en_ligne[a+1,1];
                yy:=trois_en_ligne[a+1,2];
                d:=trois_en_ligne[a,3];
        end;

	if recherche=4 then
        begin
                x:=quatre_en_ligne[a,1];
                y:=quatre_en_ligne[a,2];
                xx:=quatre_en_ligne[a+1,1];
                yy:=quatre_en_ligne[a+1,2];
                d:=quatre_en_ligne[a,3];
        end;

	if d=1 then
                begin
                b:=0;c:=1;
                end;
        if d=2 then
                begin
                b:=1;c:=0;
                end;
        if d=3 then
                begin
                b:=1;
                c:=-1;
                end;
        if d=4 then
        	begin
		b:=1;
                c:=1;
                end;

if feuille[x-b,y-c]=2 then		{l'ordinateur encercle une position}
                        begin
			priorite_coup[prio,1]:=xx+b;
                        priorite_coup[prio,2]:=yy+c;
                        priorite_coup[prio,3]:=recherche;
                        priorite_coup[prio,4]:=20;
                        prio:=prio+1;

{                        closegraph;
                        writeln ('xx: ',xx,' yy: ',yy);
                        for b:=1to 10 do
                        writeln (priorite_coup[b,1]);
                        readln;
                        initialisation_graphique;}

                        end;
if feuille[xx+b,yy+c]=2 then
                        begin
			priorite_coup[prio,1]:=x-b;
                        priorite_coup[prio,2]:=y-c;
                        priorite_coup[prio,3]:=recherche;
                        priorite_coup[prio,4]:=20;
                        prio:=prio+1;
                        end;
if (feuille[xx+2*b,yy+2*c]=1) and (feuille[xx+b,yy+c]=0) then {l'ordinateur met un cercle si il y a un trou entre des croix}
			begin
                        priorite_coup[prio,1]:=xx+b;
                        priorite_coup[prio,2]:=yy+c;
                        priorite_coup[prio,3]:=recherche;
                        priorite_coup[prio,4]:=15;
                        prio:=prio+1;
                        end;
if (feuille[x-2*b,y-2*c]=1) and (feuille[x-b,y-c]=0) then
			begin
                        priorite_coup[prio,1]:=x-b;
                        priorite_coup[prio,2]:=y-c;
                        priorite_coup[prio,3]:=recherche;
                        priorite_coup[prio,4]:=15;
                        prio:=prio+1;
                        end;


a:=a+1;
end;
end;

procedure choix_ordinateur;
begin
decryptage_matrice;

if pos_quatre<>1 then
		begin
                recherche:=4;
                premiere_recherche;
                end;

if pos_trois<>1 then
               	begin
               	recherche:=3;
               	premiere_recherche;
               	end;

if pos_deux<>1 then
                begin
               	recherche:=2;
      		premiere_recherche;
                end;
{la derniere croix n'est pas connecter. Un piege?}
if recherche=0 then
                begin
		deuxieme_recherche;
                end;

end;

procedure depart;
begin
numero_coup:=1;
writeln ('Qui commence: joueur(j) ou ordinateur(o)');
readln (e);
if e='o' then
feuille[20,20]:=2;
initialisation_graphique;
end;

begin
depart;

for a:=1 to 40*40 do
begin
init;
choix_joueur;
choix_ordinateur;

d:=a;
for c:=1 to 50 do
if priorite_coup[c,1]<>0 then
			begin
                        a:=priorite_coup[c,1];
                        b:=priorite_coup[c,2];
                        feuille[a,b]:=2;
                        piece_ordi;
                        end;
a:=d;
readln;
cleardevice;

end;


{closegraph;
writeln (feuille[1,1]);
writeln ('x: ',pos_mat_x,' y: ',pos_mat_y);
readln;}

end.
